/*
 * UTIL.H
 *
 * Embedded Web Server
 * Copyright 1998,
 * JK microsystems, Inc. - ALL RIGHTS RESERVED
 * http://www.jkmicro.com
 *
 * THIS SOFTWARE IS NOT SHAREWARE, FREEWARE, OR PUBLIC DOMAIN.
 * IT IS THE PROPERTY OF JK microsystems.
 *
 * CUSTOMERS OF JK microsystems MAY MODIFY THE SOURCE CODE
 * AND/OR DISTRIBUTE THE BINARY IMAGE OF THIS SOFTWARE WITHOUT
 * ADDITIONAL COSTS PROVIDED IT IS RUN ONLY ON HARDWARE
 * MANUFACTURED BY JK microsystems.  ALL OTHER USE IS EXPRESSLY
 * PROHIBITED.
 *
 * THIS SOURCE CODE IS NOT TO BE DISCLOSED WITHOUT PRIOR APPROVAL
 * FROM JK microsystems.
 *
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY;
 * WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * THE TCP/IP LIBRARIES ARE COPYRIGHT
 * UNIVERSITY OF WATERLOO.
 * THE LIBRARIES ARE PROVIDED FREE OF
 * CHARGE IN THEIR ORIGINAL DISTRIBUTION FORMAT.
 *
 */

/*
   See WEBTCP.H for revision notes
 */

#ifndef __util_h
#define __util_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <bios.h>
#include <sys\stat.h>

#include "status.h"
#include "tcp.h"

#define PORT 1			// allow i/o port access from 'GET' type form, comment to disable

#ifdef PORT

#define PORT_A 0x60
#define PORT_B 0x61
#define PORT_AB_DIR 0x63
#define PORT_A_DIR_BIT 0x10
#define PORT_B_DIR_BIT 0x01
#define PORT_RELAY_IO 0x3C0

#define PORT_UF1 0xF860
#define PORT_UF1_MASK 0xF0
#define PORT_UF1D 0xF864
#define PORT_UF3 0xF870
#define PORT_UF3_MASK 0x3F
#define PORT_UF3D 0xF874

#define UF_UIO 0x8000			// arbitrary value to identify uio drivers
#define PORT_DA 0x8001			// arbitrary value to identify d/a ports

#endif

#define IO_EXT_INT	0x15		// bios i/o subsystem extension interrupt
#define MAC_FCN 0xE100			// get mac # function
#define MAC_HI 0x9000			// hi 2 octets of JKmicro company ID
#define MAC_LO 0x00C2			// low octet of JKmicro company ID

#define DOS_INT 0x21			// DOS functions interrupt
#define DOS_GETKBD 0x08			// get keyboard w/o echo

extern char pc;          		// flag for pc vs flashlite

extern union REGS regs;			// i86 processor regs

extern byte _eth_addr[];				// adapter ethernet (MAC) address
extern char far exe_share[];
extern char query[];
#endif  // end if def __util_h

